
#line 3 "lexer.c"

#define  YY_INT_ALIGNED short int

/* A lexical scanner generated by flex */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5
#define YY_FLEX_SUBMINOR_VERSION 35
#if YY_FLEX_SUBMINOR_VERSION > 0
#define FLEX_BETA
#endif

/* First, we deal with  platform-specific or compiler-specific issues. */

/* begin standard C headers. */
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

/* end standard C headers. */

/* flex integer type definitions */

#ifndef FLEXINT_H
#define FLEXINT_H

/* C99 systems have <inttypes.h>. Non-C99 systems may or may not. */

#if defined (__STDC_VERSION__) && __STDC_VERSION__ >= 199901L

/* C99 says to define __STDC_LIMIT_MACROS before including stdint.h,
 * if you want the limit (max/min) macros for int types. 
 */
#ifndef __STDC_LIMIT_MACROS
#define __STDC_LIMIT_MACROS 1
#endif

#include <inttypes.h>
typedef int8_t flex_int8_t;
typedef uint8_t flex_uint8_t;
typedef int16_t flex_int16_t;
typedef uint16_t flex_uint16_t;
typedef int32_t flex_int32_t;
typedef uint32_t flex_uint32_t;
#else
typedef signed char flex_int8_t;
typedef short int flex_int16_t;
typedef int flex_int32_t;
typedef unsigned char flex_uint8_t; 
typedef unsigned short int flex_uint16_t;
typedef unsigned int flex_uint32_t;

/* Limits of integral types. */
#ifndef INT8_MIN
#define INT8_MIN               (-128)
#endif
#ifndef INT16_MIN
#define INT16_MIN              (-32767-1)
#endif
#ifndef INT32_MIN
#define INT32_MIN              (-2147483647-1)
#endif
#ifndef INT8_MAX
#define INT8_MAX               (127)
#endif
#ifndef INT16_MAX
#define INT16_MAX              (32767)
#endif
#ifndef INT32_MAX
#define INT32_MAX              (2147483647)
#endif
#ifndef UINT8_MAX
#define UINT8_MAX              (255U)
#endif
#ifndef UINT16_MAX
#define UINT16_MAX             (65535U)
#endif
#ifndef UINT32_MAX
#define UINT32_MAX             (4294967295U)
#endif

#endif /* ! C99 */

#endif /* ! FLEXINT_H */

#ifdef __cplusplus

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

/* C99 requires __STDC__ to be defined as 1. */
#if defined (__STDC__)

#define YY_USE_CONST

#endif	/* defined (__STDC__) */
#endif	/* ! __cplusplus */

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN (yy_start) = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START (((yy_start) - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart(yyin  )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#ifndef YY_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k.
 * Moreover, YY_BUF_SIZE is 2*YY_READ_BUF_SIZE in the general case.
 * Ditto for the __ia64__ case accordingly.
 */
#define YY_BUF_SIZE 32768
#else
#define YY_BUF_SIZE 16384
#endif /* __ia64__ */
#endif

/* The state buf must be large enough to hold one state per character in the main buffer.
 */
#define YY_STATE_BUF_SIZE   ((YY_BUF_SIZE + 2) * sizeof(yy_state_type))

#ifndef YY_TYPEDEF_YY_BUFFER_STATE
#define YY_TYPEDEF_YY_BUFFER_STATE
typedef struct yy_buffer_state *YY_BUFFER_STATE;
#endif

extern int yyleng;

extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

    /* Note: We specifically omit the test for yy_rule_can_match_eol because it requires
     *       access to the local variable yy_act. Since yyless() is a macro, it would break
     *       existing scanners that call yyless() from OUTSIDE yylex. 
     *       One obvious solution it to make yy_act a global. I tried that, and saw
     *       a 5% performance hit in a non-yylineno scanner, because yy_act is
     *       normally declared as a register variable-- so it is not worth it.
     */
    #define  YY_LESS_LINENO(n) \
            do { \
                int yyl;\
                for ( yyl = n; yyl < yyleng; ++yyl )\
                    if ( yytext[yyl] == '\n' )\
                        --yylineno;\
            }while(0)
    
/* Return all but the first "n" matched characters back to the input stream. */
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		*yy_cp = (yy_hold_char); \
		YY_RESTORE_YY_MORE_OFFSET \
		(yy_c_buf_p) = yy_cp = yy_bp + yyless_macro_arg - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, (yytext_ptr)  )

#ifndef YY_TYPEDEF_YY_SIZE_T
#define YY_TYPEDEF_YY_SIZE_T
typedef size_t yy_size_t;
#endif

#ifndef YY_STRUCT_YY_BUFFER_STATE
#define YY_STRUCT_YY_BUFFER_STATE
struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

    int yy_bs_lineno; /**< The line count. */
    int yy_bs_column; /**< The column count. */
    
	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;

#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2

	};
#endif /* !YY_STRUCT_YY_BUFFER_STATE */

/* Stack of input buffers. */
static size_t yy_buffer_stack_top = 0; /**< index of top of stack. */
static size_t yy_buffer_stack_max = 0; /**< capacity of stack. */
static YY_BUFFER_STATE * yy_buffer_stack = 0; /**< Stack as an array. */

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 *
 * Returns the top of the stack, or NULL.
 */
#define YY_CURRENT_BUFFER ( (yy_buffer_stack) \
                          ? (yy_buffer_stack)[(yy_buffer_stack_top)] \
                          : NULL)

/* Same as previous macro, but useful when we know that the buffer stack is not
 * NULL or when we need an lvalue. For internal use only.
 */
#define YY_CURRENT_BUFFER_LVALUE (yy_buffer_stack)[(yy_buffer_stack_top)]

/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;
static int yy_n_chars;		/* number of characters read into yy_ch_buf */
int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 0;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart (FILE *input_file  );
void yy_switch_to_buffer (YY_BUFFER_STATE new_buffer  );
YY_BUFFER_STATE yy_create_buffer (FILE *file,int size  );
void yy_delete_buffer (YY_BUFFER_STATE b  );
void yy_flush_buffer (YY_BUFFER_STATE b  );
void yypush_buffer_state (YY_BUFFER_STATE new_buffer  );
void yypop_buffer_state (void );

static void yyensure_buffer_stack (void );
static void yy_load_buffer_state (void );
static void yy_init_buffer (YY_BUFFER_STATE b,FILE *file  );

#define YY_FLUSH_BUFFER yy_flush_buffer(YY_CURRENT_BUFFER )

YY_BUFFER_STATE yy_scan_buffer (char *base,yy_size_t size  );
YY_BUFFER_STATE yy_scan_string (yyconst char *yy_str  );
YY_BUFFER_STATE yy_scan_bytes (yyconst char *bytes,int len  );

void *yyalloc (yy_size_t  );
void *yyrealloc (void *,yy_size_t  );
void yyfree (void *  );

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){ \
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! YY_CURRENT_BUFFER ){\
        yyensure_buffer_stack (); \
		YY_CURRENT_BUFFER_LVALUE =    \
            yy_create_buffer(yyin,YY_BUF_SIZE ); \
	} \
	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (YY_CURRENT_BUFFER_LVALUE->yy_at_bol)

/* Begin user sect3 */

#define yywrap(n) 1
#define YY_SKIP_YYWRAP

typedef unsigned char YY_CHAR;

FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;

typedef int yy_state_type;

extern int yylineno;

int yylineno = 1;

extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state (void );
static yy_state_type yy_try_NUL_trans (yy_state_type current_state  );
static int yy_get_next_buffer (void );
static void yy_fatal_error (yyconst char msg[]  );

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	(yytext_ptr) = yy_bp; \
	yyleng = (size_t) (yy_cp - yy_bp); \
	(yy_hold_char) = *yy_cp; \
	*yy_cp = '\0'; \
	(yy_c_buf_p) = yy_cp;

#define YY_NUM_RULES 95
#define YY_END_OF_BUFFER 96
/* This struct is not used in this scanner,
   but its presence is necessary. */
struct yy_trans_info
	{
	flex_int32_t yy_verify;
	flex_int32_t yy_nxt;
	};
static yyconst flex_int16_t yy_accept[429] =
    {   0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,    0,   96,   94,   93,   93,   94,   94,
       94,   42,   67,   94,   94,   94,   94,   72,   94,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       43,   44,   66,   93,   67,   94,   94,   94,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       86,   85,   85,   86,   86,   73,   75,   78,   74,   76,
       77,   83,   83,   83,   54,   54,   53,   52,   51,   40,
       39,   39,   40,   38,   36,   36,   38,   38,   38,   11,
       13,   38,   17,   18,    9,   12,    8,   14,   10,   32,

       32,    3,   24,    7,   25,   37,   37,   37,   37,   37,
       37,   37,   15,   16,    0,    0,   92,    0,    0,   71,
       71,   71,   69,   80,   72,    0,   72,   72,   72,   72,
       72,    1,   72,   72,   72,   72,   72,   72,   72,   72,
        0,    0,    0,    0,    0,    0,    0,    0,   71,    0,
        0,    0,   72,   72,   72,   72,   72,   72,   72,   72,
        1,   72,   72,   72,   72,   72,   72,   72,   72,    0,
       79,    0,    0,   84,   74,   83,   83,   82,   55,   51,
       41,   22,    0,   35,    0,    0,   33,    0,   34,    0,
       81,   30,    0,   32,   20,   23,   19,   21,   37,   37,

       37,   37,    4,   37,   37,    0,   88,    0,   87,    0,
        0,   90,    0,   71,   71,   68,   68,   69,   70,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   48,
       72,   72,   72,   65,    0,   91,   71,    0,    0,   65,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       48,   72,   72,   72,    0,    0,    0,   33,    0,    0,
       31,    5,   37,    6,   37,   37,    0,   89,   71,   68,
       68,   70,   72,   47,   72,   46,   72,   72,   72,   72,
       72,   72,   45,   72,   72,    0,    0,    0,   72,   47,
       72,   46,   72,   72,   72,   72,   72,   72,   45,   72,

       72,    0,    0,    0,    0,    0,   37,   37,    2,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   49,    0,
        0,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       49,    0,   37,   37,   72,   72,   72,    0,   61,   72,
       72,   72,   72,   72,    0,    0,   72,   72,   72,   72,
       72,   72,   72,   72,   37,   37,    0,   63,   72,    0,
       56,    0,   62,   72,   72,   72,   72,    0,   64,   72,
       72,   72,   72,   72,   37,   37,   72,   72,   72,    0,
       58,   72,   72,   72,   72,   72,   26,   37,    0,   60,
       72,    0,   59,    0,   57,   72,   37,   37,   72,   72,

       27,   28,   72,   72,   37,   72,   72,   29,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   50,    0
    } ;

static yyconst flex_int32_t yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    4,    5,    6,    7,    8,    9,   10,   11,   12,
       13,   14,   15,   16,   17,   18,   19,   20,   21,   21,
       21,   21,   21,   21,   21,   22,   22,   23,   24,   25,
       26,   27,   28,   29,   30,   31,   32,   33,   34,   35,
       36,   37,   38,   39,   39,   40,   41,   42,   43,   44,
       39,   45,   46,   47,   48,   49,   50,   51,   52,   39,
       53,   54,   55,   29,   56,    1,   57,   58,   59,   60,

       61,   62,   63,   64,   65,   39,   39,   66,   67,   68,
       69,   70,   39,   71,   72,   73,   74,   49,   75,   76,
       77,   39,   78,   29,   79,   80,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst flex_int32_t yy_meta[81] =
    {   0,
        1,    2,    3,    4,    5,    6,    1,    7,    1,    1,
        6,    1,    1,    8,    9,   10,   11,   12,    1,   13,
       13,   14,   15,   16,    1,   17,    1,   18,    1,   19,
       20,   21,   21,   21,   19,   22,   22,   22,   22,   22,
       22,   23,   22,   22,   23,   22,   23,   22,   24,   22,
       25,   22,    1,    6,    1,   26,   19,   20,   21,   21,
       21,   19,   22,   22,   22,   22,   22,   23,   22,   22,
       23,   22,   23,   22,   22,   25,   22,    1,    1,    1
    } ;

static yyconst flex_int16_t yy_base[501] =
    {   0,
        0,   80,  160,    0,  238,  239,  241,  244,  236,  241,
      263,    0,  343,    0, 1080, 3127, 3127, 3127,    0, 1075,
        0, 3127, 3127, 1053,  236,    0, 1047,    0,    0,  392,
      395,  387,  388,  394,  388,  387,  385,  400,  405,  395,
     3127, 3127,    0,  463,  424,  953,  486,  462,  502,  529,
      572,  538,  540,  568,  505,  569,  570,  612,  613,  592,
     3127, 3127, 3127,  420,  953, 3127, 3127, 3127,    0, 3127,
     3127,  943,  933,  899,    0, 3127, 3127, 3127,  428, 3127,
     3127, 3127,    0, 3127, 3127, 3127,  881,  435,  438, 3127,
     3127,  449, 3127, 3127, 3127, 3127, 3127, 3127,  888,  455,

      487, 3127,  233,  856,  852,  413,    0,  461,  485,  484,
      486,  488, 3127, 3127,  534,  841, 3127,  685,  569,    0,
      617,  518,    0, 3127,    0,  801,  509,  535,  537,  545,
      588,    0,  588,  524,  611,  610,  604,  609,  612,  720,
      765,  646,    0,  801,  752,    0,  758,  781,  792,  773,
      667,  806,  835,  814,  859,  872,  796,  791,  740,  794,
      742,  795,  851,  861,  859,  778,  854,  862,  866,  554,
     3127,  448,  774, 3127,    0,  772,  681, 3127,    0,  834,
        0, 3127,  860, 3127,  896,    0,    0,  760, 3127,  900,
     3127,  451,    0,  920, 3127, 3127, 3127, 3127,    0,  798,

      858,  858,    0,  880,  899,  946, 3127,  665, 3127,  976,
      950,  959,  630,  966,  613,    0,    0,    0,    0,  906,
     1017, 1012, 1025, 1029, 1014, 1015, 1020, 1021, 1032,    0,
     1024, 1025, 1036,    0, 1069, 3127, 1072,  939,  786, 1087,
     1100, 1111, 1094, 1045, 1079, 1096, 1102, 1037, 1108, 1119,
     1042, 1117, 1129, 1141, 1143,  938,    0,    0,  944,    0,
     3127,    0, 1099,    0, 1113, 1137,  574, 3127,  560,    0,
        0,    0, 1139,    0, 1139,    0, 1066, 1141, 1149, 1145,
     1078, 1145,    0, 1152, 1146,  970, 1094, 1205, 1158, 1154,
     1156, 1160, 1183, 1164, 1166, 1188, 1191, 1195, 1194, 1196,

     1198, 1245, 1134,    0, 1222,    0, 1216, 1197,    0, 1206,
     1220, 1213, 1278, 1222, 1215, 1218, 1234, 1239,    0, 1271,
      563, 1236, 1258, 1245, 1289, 1260, 1265, 1267, 1269, 1280,
     1257, 1300, 1248, 1268, 1315, 1274, 1341, 1345, 3127, 1348,
     1300, 1289, 1292, 1294,  659,  521, 1366, 1316, 1369, 1373,
     1334, 1339, 1348, 1349, 1319,  573, 1395, 3127, 1317, 1399,
     3127, 1414, 3127, 1348,  808, 1421, 1358,  479,  471, 1380,
     1394, 1388, 1439, 1396, 1391, 1366, 1446, 1406, 1464, 1470,
     3127, 1481, 1484, 1437, 1487, 1504,  379, 1391, 1507, 3127,
     1412, 1510, 3127, 1526, 3127, 1415, 1432, 1457, 1464, 1486,

        0,  374, 1429, 1452, 1466, 1477, 1494,    0, 1475, 1495,
     1505, 1506, 1481, 1514, 1488, 1517, 1504, 1528, 1517, 1545,
     1517, 1539, 1510, 1544,  239, 1546, 3127, 3127, 1615, 1641,
     1667, 1693, 1719, 1727, 1752, 1778, 1796, 1810, 1834, 1852,
     1870, 1895, 1915, 1933, 1959, 1985, 2000, 2026, 2052, 2067,
     2093, 2115, 2140, 2154, 2180, 2206, 2220, 2244, 2262, 2277,
     2296, 2317, 2342, 2365, 2386, 2405, 2431, 2452, 2476, 2491,
     2517, 2543, 2558, 2584, 2605, 2612, 2633, 2659, 2680, 2693,
     2702, 2728, 2754, 2780, 2806, 2832, 2858, 2884, 2910, 2928,
     2950, 2972, 2993, 3012, 3038, 3052, 3061, 3070, 3079, 3100

    } ;

static yyconst flex_int16_t yy_def[501] =
    {   0,
      428,  428,  428,    3,  429,  429,  430,  430,  431,  431,
      428,   11,  428,   13,  428,  428,  428,  428,  432,  433,
      434,  428,  428,  428,  435,  435,  436,  437,  438,  437,
      437,  437,  437,  437,  437,  437,  437,  437,  437,  437,
      428,  428,  435,  439,  440,  441,  442,  443,  444,  444,
      444,   51,   51,   51,   51,   51,   51,   51,   51,   51,
      428,  428,  428,  445,  446,  428,  428,  428,  447,  428,
      428,  448,  448,  428,  449,  428,  428,  428,  428,  428,
      428,  428,  450,  428,  428,  428,  428,  451,  452,  428,
      428,  453,  428,  428,  428,  428,  428,  428,  428,  428,

      428,  428,  428,  428,  428,  454,  454,  454,  454,  454,
      454,  454,  428,  428,  432,  433,  428,  428,  428,  435,
      435,  455,  456,  428,  437,  457,  437,  437,  437,  437,
      437,  437,  437,  437,  437,  437,  437,  437,  437,  437,
      458,  459,  460,  461,  459,  462,  428,  460,  463,  461,
      461,  464,  465,  437,  466,  466,  156,  156,  156,  156,
      156,  156,  156,  156,  156,  156,  156,  156,  156,  467,
      428,  468,  469,  428,  470,  471,  471,  428,  472,  428,
      473,  428,  474,  428,  475,  476,  477,  478,  428,  479,
      428,  428,  480,  428,  428,  428,  428,  428,  481,  481,

      481,  481,  481,  481,  481,  428,  428,  482,  428,  428,
      428,  428,  483,  484,  485,  486,  487,  488,  489,  490,
      490,  490,  490,  490,  490,  490,  490,  490,  490,  490,
      490,  490,  490,  491,  428,  428,  484,  428,  492,  493,
      494,  494,  242,  242,  242,  242,  242,  242,  242,  242,
      242,  242,  242,  242,  495,  428,  496,  477,  428,  497,
      428,  481,  481,  481,  481,  481,  483,  428,  485,  486,
      487,  489,  490,  490,  490,  490,  490,  490,  490,  490,
      490,  490,  490,  490,  490,  492,  492,  492,  242,  242,
      242,  242,  242,  242,  242,  242,  242,  242,  242,  242,

      242,  495,  428,  498,  428,  499,  481,  481,  481,  490,
      490,  490,  490,  490,  490,  490,  490,  490,  490,  428,
      428,  242,  242,  242,  242,  242,  242,  242,  242,  242,
      242,  495,  481,  481,  490,  490,  490,  428,  428,  490,
      490,  490,  490,  490,  428,  500,  242,  242,  242,  242,
      242,  242,  242,  242,  481,  481,  428,  428,  490,  428,
      428,  428,  428,  490,  490,  490,  490,  500,  500,  242,
      242,  242,  242,  242,  481,  481,  490,  490,  490,  428,
      428,  490,  242,  242,  242,  242,  481,  481,  428,  428,
      490,  428,  428,  428,  428,  242,  481,  481,  490,  242,

      481,  481,  490,  242,  481,  490,  242,  481,  490,  242,
      490,  242,  490,  242,  490,  242,  490,  242,  490,  242,
      490,  242,  490,  242,  490,  242,  428,    0,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428

    } ;

static yyconst flex_int16_t yy_nxt[3208] =
    {   0,
       16,   17,   18,   17,   19,   16,   20,   21,   16,   22,
       16,   16,   16,   23,   24,   16,   25,   26,   27,   28,
       28,   28,   29,   16,   16,   16,   26,   26,   26,   30,
       28,   31,   28,   32,   28,   33,   28,   34,   28,   28,
       35,   28,   28,   36,   37,   38,   39,   40,   28,   28,
       28,   28,   16,   16,   16,   28,   30,   28,   31,   28,
       32,   28,   33,   28,   34,   28,   35,   28,   28,   36,
       37,   38,   39,   40,   28,   28,   28,   41,   42,   43,
       16,   44,   18,   44,   19,   16,   20,   21,   16,   22,
       16,   16,   16,   45,   46,   16,   47,   26,   27,   28,

       28,   28,   48,   16,   16,   16,   26,   26,   26,   49,
       50,   51,   50,   52,   50,   53,   50,   54,   50,   50,
       55,   50,   50,   56,   57,   58,   59,   60,   50,   50,
       50,   50,   16,   16,   16,   28,   49,   50,   51,   50,
       52,   50,   53,   50,   54,   50,   55,   50,   50,   56,
       57,   58,   59,   60,   50,   50,   50,   41,   42,   43,
       61,   62,   63,   62,   61,   64,   65,   61,   61,   61,
       61,   61,   66,   61,   61,   67,   61,   61,   61,   61,
       61,   61,   61,   61,   61,   68,   61,   61,   61,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,

       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   70,   61,   71,   61,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   69,   69,   69,
       69,   69,   69,   69,   69,   69,   69,   61,   61,   61,
       73,   73,   76,   76,   76,   76,   76,   76,   78,  121,
      427,   74,   74,   78,  122,   79,   79,   79,  195,  196,
       79,   79,   79,   80,   81,   82,   81,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   80,   80,   80,   80,   80,   80,   80,   80,
       80,   80,   83,   83,   83,   83,   83,   83,   83,   83,

       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   80,   80,   80,   80,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       83,   83,   83,   83,   83,   83,   83,   83,   83,   83,
       80,   80,   80,   84,   85,   86,   85,   87,   88,   84,
       89,   90,   91,   92,   93,   94,   95,   96,   97,   98,
       84,   99,  100,  101,  101,   84,  102,  103,  104,  105,
       84,   84,  106,  107,  108,  107,  107,  107,  107,  107,
      107,  107,  107,  107,  109,  110,  107,  107,  111,  112,
      107,  107,  107,  107,  107,  113,   84,  114,   84,  106,

      107,  108,  107,  107,  107,  107,  107,  107,  107,  107,
      109,  110,  107,  107,  111,  112,  107,  107,  107,  107,
       84,   84,   84,  127,  128,  171,  130,  131,  132,  405,
      134,  135,  136,  137,  397,  133,  140,  129,  139,  146,
      184,  146,  186,  147,  147,  186,  138,  180,  180,  180,
      127,  128,  130,  131,  200,  132,  134,  135,  136,  189,
      137,  133,  140,  129,  141,  139,  141,  255,  255,  150,
      192,  192,  138,  172,  192,  192,  369,  143,  151,  143,
      200,  126,  126,  126,  369,  144,  120,  120,  185,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  121,

      120,  120,  190,  201,  122,  193,  194,  194,  194,  120,
      120,  120,  120,  120,  120,  145,  125,  153,  125,  146,
      217,  154,  154,  125,  205,  125,  369,  202,  203,  201,
      193,  120,  204,  156,  155,  206,  207,  206,  120,  120,
      120,  120,  145,  125,  153,  125,  146,  163,  154,  154,
      125,  205,  125,  202,  203,  220,  226,  125,  204,  171,
      156,  155,  268,  120,  120,  120,  345,  155,  346,  155,
      211,  212,  211,  163,  221,  213,  268,  159,  222,  160,
      155,  220,  155,  226,  125,  145,  125,  153,  125,  146,
      223,  154,  154,  125,  155,  125,  155,  155,  155,  155,

      221,  157,  161,  159,  222,  160,  155,  172,  155,  162,
      155,  155,  155,  164,  158,  268,  223,  165,  214,  212,
      214,  155,  376,  215,  155,  155,  155,  125,  157,  161,
      224,  225,  268,  169,  155,  162,  155,  155,  155,  164,
      158,  155,  155,  165,  227,  166,  168,  376,  155,  229,
      230,  231,  232,  228,  155,  155,  224,  225,  167,  169,
      155,  146,  345,  146,  346,  147,  147,  209,  155,  155,
      238,  227,  166,  168,  428,  229,  230,  231,  232,  228,
      155,  155,  239,  177,  167,  208,  208,  209,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,

      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  208,  208,  208,
      208,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  208,  208,  208,  233,  141,  146,  141,  146,
      189,  147,  147,  146,  177,  146,  174,  147,  147,  143,
      428,  143,  235,  236,  235,  244,  155,  144,  155,  286,
      287,  233,  120,  237,  236,  237,  120,  120,  120,  120,

      120,  120,  120,  120,  120,  120,  120,  120,  150,  238,
      120,  244,  155,  190,  155,  120,  120,  120,  120,  120,
      120,  239,  151,  219,  251,  126,  126,  126,  219,  153,
      262,  146,  243,  154,  154,  242,  245,  155,  246,  234,
      155,  155,  155,  117,  120,  120,  120,  120,  234,  125,
      251,  125,  234,  180,  180,  180,  125,  262,  243,  379,
      234,  242,  245,  155,  246,  184,  155,  155,  155,  120,
      120,  120,  145,  125,  153,  125,  146,  198,  154,  154,
      125,  197,  125,  247,  379,  145,  125,  153,  125,  146,
      125,  154,  154,  125,  248,  125,  252,  155,  250,  263,

      155,  191,  253,  249,  264,  155,  182,  155,  155,  265,
      247,  254,  155,  185,  125,  256,  256,  178,  241,  259,
      259,  248,  252,  155,  250,  263,  155,  125,  253,  249,
      264,  155,  266,  155,  155,  177,  265,  254,  155,  194,
      194,  194,  238,  273,  241,  177,  257,  206,  207,  206,
      260,  211,  212,  211,  239,  174,  213,  303,  303,  266,
      211,  212,  211,  305,  305,  213,  119,  214,  212,  214,
      273,  257,  215,  286,  287,  260,  208,  208,  209,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,

      208,  208,  208,  208,  208,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  208,  208,
      208,  208,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  208,  208,  208,  274,  275,  276,  277,
      124,  278,  279,  280,  281,  282,  119,  283,  284,  285,
      235,  236,  235,  237,  236,  237,  155,  117,  292,  428,
      296,  155,  274,  275,  155,  276,  277,  278,  279,  280,
      281,  234,  282,  283,  284,  312,  285,  428,  428,  428,

      234,  125,  155,  125,  234,  292,  296,  155,  125,  293,
      155,  316,  234,  145,  125,  153,  125,  146,  155,  154,
      154,  125,  312,  125,  145,  125,  153,  125,  146,  428,
      154,  154,  125,  155,  125,  155,  293,  289,  316,  291,
      428,  155,  125,  294,  155,  307,  428,  155,  171,  295,
      290,  297,  298,  183,  183,  125,  155,  308,  155,  155,
      299,  155,  302,  302,  289,  291,  125,  155,  155,  294,
      428,  307,  300,  155,  301,  295,  290,  297,  309,  298,
      155,  310,  155,  308,  155,  311,  299,  313,  314,  315,
      317,  318,  319,  155,  155,  155,  172,  155,  300,  155,

      322,  301,  323,  155,  309,  326,  155,  310,  320,  428,
      325,  311,  324,  313,  314,  315,  317,  318,  319,  155,
      321,  155,  155,  155,  328,  155,  322,  155,  323,  155,
      155,  326,  327,  155,  155,  330,  325,  155,  428,  324,
      329,  188,  188,  334,  331,  333,  428,  335,  155,  336,
      171,  328,  337,  155,  428,  340,  155,  341,  327,  155,
      155,  330,  342,  155,  332,  332,  329,  343,  344,  334,
      331,  428,  333,  335,  320,  155,  336,  347,  337,  338,
      338,  338,  340,  341,  349,  355,  321,  348,  342,  339,
      338,  338,  338,  350,  343,  344,  155,  155,  172,  155,

      339,  155,  353,  347,  155,  171,  155,  351,  155,  354,
      349,  352,  355,  356,  348,  359,  357,  357,  357,  155,
      350,  428,  155,  155,  428,  155,  358,  428,  155,  353,
      155,  364,  155,  351,  155,  365,  354,  352,  366,  356,
      367,  359,  360,  360,  360,  155,  338,  338,  338,  362,
      362,  362,  361,  172,  155,  155,  339,  370,  364,  363,
      375,  365,  428,  377,  366,  371,  367,  357,  357,  357,
      360,  360,  360,  155,  362,  362,  362,  358,  155,  428,
      361,  155,  378,  370,  363,  372,  375,  155,  155,  377,
      428,  382,  371,  428,  373,  374,  357,  357,  357,  155,

      360,  360,  360,  388,  155,  155,  358,  428,  155,  378,
      361,  372,  155,  155,  155,  362,  362,  362,  382,  155,
      373,  374,  380,  380,  380,  363,  383,  155,  384,  386,
      388,  155,  381,  155,  155,  155,  387,  398,  155,  385,
      380,  380,  380,  391,  428,  155,  428,  389,  389,  389,
      381,  399,  383,  155,  400,  384,  386,  390,  428,  155,
      428,  155,  387,  398,  385,  392,  392,  392,  406,  401,
      391,  380,  380,  380,  396,  393,  155,  399,  155,  428,
      400,  381,  394,  394,  394,  389,  389,  389,  392,  392,
      392,  407,  395,  402,  406,  390,  401,  403,  393,  428,

      428,  396,  155,  408,  155,  394,  394,  394,  389,  389,
      389,  392,  392,  392,  409,  395,  411,  407,  390,  404,
      402,  393,  415,  155,  403,  155,  155,  394,  394,  394,
      408,  410,  428,  155,  155,  417,  412,  395,  413,  414,
      428,  409,  411,  155,  419,  155,  404,  421,  415,  155,
      423,  155,  155,  155,  425,  416,  155,  427,  410,  155,
      155,  417,  412,  428,  418,  413,  414,  155,  420,  155,
      419,  155,  424,  428,  421,  422,  428,  423,  155,  155,
      425,  416,  155,  155,  155,  155,  428,  428,  426,  428,
      418,  428,  428,  155,  420,  428,  428,  428,  428,  424,

      428,  428,  422,  428,  155,  428,  428,  428,  428,  155,
      155,  155,  428,  428,  426,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   72,   72,   72,   72,   72,   72,   72,   72,   72,
       72,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   75,   75,   75,
       75,   75,   75,   75,   75,   75,   75,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,   77,   77,   77,   77,   77,   77,   77,
       77,   77,   77,  115,  428,  428,  428,  115,  115,  115,

      115,  115,  115,  115,  115,  115,  115,  115,  115,  115,
      115,  115,  115,  115,  115,  115,  115,  115,  115,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  116,  116,  116,  116,  116,
      116,  116,  116,  116,  116,  118,  118,  118,  118,  118,
      118,  118,  120,  120,  428,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,
      123,  123,  123,  123,  123,  123,  123,  123,  123,  123,

      123,  123,  123,  123,  125,  125,  125,  428,  125,  125,
      428,  125,  428,  428,  125,  125,  125,  125,  125,  125,
      125,  125,  126,  126,  428,  428,  428,  428,  126,  126,
      126,  126,  126,  126,  126,  142,  428,  142,  428,  428,
      428,  142,  142,  428,  142,  428,  428,  428,  142,  428,
      428,  428,  142,  142,  142,  142,  142,  142,  142,  145,
      428,  145,  428,  145,  145,  428,  428,  428,  428,  428,
      145,  145,  145,  145,  145,  145,  145,  148,  428,  428,
      148,  148,  148,  148,  148,  428,  428,  428,  148,  148,
      148,  148,  148,  148,  148,  149,  149,  428,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  152,  428,  428,  428,  152,  428,  152,  152,  428,
      428,  428,  428,  152,  152,  152,  152,  152,  152,  152,
      155,  155,  155,  155,  155,  155,  155,  428,  155,  428,
      428,  155,  155,  155,  155,  155,  155,  155,  155,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,

      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  175,  175,  175,  428,  428,  428,  428,  175,  175,
      175,  175,  175,  175,  175,  175,  176,  176,  176,  176,
      176,  176,  176,  428,  176,  176,  176,  176,  176,  176,
      176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
      176,  176,  179,  428,  428,  428,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  181,  181,
      181,  428,  428,  428,  428,  181,  181,  181,  181,  181,
      181,  181,  181,  183,  183,  183,  183,  183,  183,  428,

      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  183,  183,  183,  183,  183,  183,  183,  187,
      428,  187,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  187,  187,  187,  187,  187,  187,  187,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  199,  199,  428,  428,
      428,  428,  199,  199,  199,  199,  199,  199,  199,  199,
      216,  216,  216,  216,  216,  216,  216,  216,  216,  216,
      216,  216,  216,  216,  216,  216,  216,  216,  216,  216,

      216,  216,  216,  216,  216,  216,  218,  218,  428,  218,
      218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
      218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
      218,  218,  126,  126,  126,  428,  428,  428,  126,  126,
      126,  126,  126,  126,  126,  142,  428,  142,  428,  428,
      428,  142,  142,  428,  142,  428,  428,  428,  142,  428,
      428,  428,  142,  142,  142,  142,  142,  142,  142,  145,
      428,  145,  428,  145,  145,  428,  428,  428,  428,  428,
      145,  145,  145,  145,  145,  145,  145,  148,  148,  148,
      148,  148,  428,  428,  428,  148,  148,  148,  148,  148,

      148,  148,  151,  428,  428,  428,  151,  428,  428,  428,
      428,  428,  428,  428,  151,  151,  151,  151,  151,  151,
      151,  234,  428,  428,  234,  428,  234,  428,  234,  234,
      428,  428,  234,  234,  428,  234,  234,  234,  234,  234,
      234,  234,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  149,  149,
      149,  149,  149,  149,  149,  149,  149,  149,  152,  428,
      428,  428,  428,  428,  152,  152,  428,  152,  152,  152,
      428,  428,  428,  152,  152,  152,  152,  152,  152,  152,
      240,  428,  428,  240,  240,  240,  240,  240,  240,  240,

      428,  240,  240,  428,  240,  240,  240,  240,  240,  240,
      240,  240,  155,  155,  155,  155,  155,  155,  155,  428,
      155,  428,  428,  155,  155,  155,  155,  155,  155,  155,
      155,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  428,  428,
      428,  428,  428,  428,  170,  428,  428,  428,  428,  170,
      170,  170,  428,  428,  170,  170,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,
      173,  173,  173,  173,  173,  173,  173,  173,  173,  173,

      173,  173,  175,  175,  175,  428,  428,  428,  428,  175,
      175,  175,  175,  175,  175,  175,  175,  176,  176,  176,
      176,  176,  176,  176,  428,  176,  176,  176,  176,  176,
      176,  176,  176,  176,  176,  176,  176,  176,  176,  176,
      176,  176,  176,  179,  428,  428,  428,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  179,
      179,  179,  179,  179,  179,  179,  179,  179,  179,  181,
      181,  181,  428,  428,  428,  428,  181,  181,  181,  181,
      181,  181,  181,  181,  183,  183,  183,  183,  183,  183,
      428,  183,  183,  183,  183,  183,  183,  183,  183,  183,

      183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
      183,  183,  428,  428,  428,  428,  428,  183,  428,  428,
      428,  428,  428,  428,  183,  428,  428,  183,  428,  183,
      187,  187,  187,  187,  187,  187,  187,  258,  428,  428,
      428,  428,  428,  258,  258,  258,  258,  428,  428,  428,
      428,  258,  258,  258,  258,  258,  258,  258,  258,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  188,  188,  188,
      188,  188,  188,  188,  188,  188,  188,  428,  428,  428,
      428,  428,  188,  428,  428,  428,  428,  428,  428,  188,

      428,  428,  188,  428,  188,  261,  428,  428,  428,  428,
      428,  261,  261,  261,  199,  199,  428,  428,  428,  428,
      199,  199,  199,  199,  199,  199,  199,  199,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  208,  208,  208,  208,  208,  208,
      208,  208,  208,  208,  267,  267,  267,  267,  267,  267,
      267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
      267,  267,  267,  267,  267,  267,  267,  267,  267,  267,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,
      120,  120,  120,  120,  120,  120,  120,  120,  120,  120,

      120,  120,  120,  120,  120,  120,  269,  269,  269,  269,
      269,  269,  269,  269,  269,  269,  269,  269,  269,  269,
      269,  269,  269,  269,  269,  269,  269,  269,  269,  269,
      269,  269,  270,  270,  428,  270,  270,  270,  270,  270,
      270,  270,  270,  270,  270,  270,  270,  270,  270,  270,
      270,  270,  270,  270,  270,  270,  270,  270,  271,  271,
      428,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  271,  271,  271,  271,  271,  271,  271,  271,
      271,  271,  271,  271,  218,  218,  428,  218,  218,  218,
      218,  218,  218,  218,  218,  218,  218,  218,  218,  218,

      218,  218,  218,  218,  218,  218,  218,  218,  218,  218,
      272,  272,  428,  272,  272,  272,  272,  272,  272,  272,
      272,  272,  272,  272,  272,  272,  272,  272,  272,  272,
      272,  272,  272,  272,  272,  272,  125,  125,  125,  428,
      125,  125,  428,  125,  428,  428,  125,  125,  125,  125,
      125,  125,  125,  125,  234,  428,  428,  234,  428,  234,
      428,  234,  234,  428,  428,  234,  234,  428,  234,  234,
      234,  234,  234,  234,  234,  288,  288,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      288,  288,  288,  288,  288,  288,  288,  240,  428,  428,

      240,  240,  240,  240,  240,  240,  240,  428,  240,  240,
      428,  240,  240,  240,  240,  240,  240,  240,  240,  155,
      155,  155,  155,  155,  155,  155,  428,  155,  428,  428,
      155,  155,  155,  155,  155,  155,  155,  155,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  170,  170,  170,  170,  170,  170,
      170,  170,  170,  170,  304,  304,  428,  428,  428,  428,
      304,  304,  304,  306,  306,  428,  428,  428,  428,  306,
      306,  306,  183,  183,  428,  428,  428,  428,  183,  183,
      183,  188,  188,  428,  428,  428,  428,  188,  188,  188,

      368,  368,  428,  368,  368,  368,  368,  368,  368,  368,
      368,  368,  368,  368,  368,  368,  368,  368,  368,  368,
      368,  368,  368,  368,  368,  368,   15,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,

      428,  428,  428,  428,  428,  428,  428
    } ;

static yyconst flex_int16_t yy_chk[3208] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,

        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        2,    2,    2,    2,    2,    2,    2,    2,    2,    2,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,

        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        3,    3,    3,    3,    3,    3,    3,    3,    3,    3,
        5,    6,    7,    7,    7,    8,    8,    8,    9,   25,
      425,    5,    6,   10,   25,    9,    9,    9,  103,  103,
       10,   10,   10,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,

       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   11,   11,   11,   11,   11,   11,   11,
       11,   11,   11,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,

       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   13,   13,   13,   13,   13,   13,   13,
       13,   13,   13,   30,   31,   64,   32,   33,   34,  402,
       35,   36,   37,   38,  387,   34,   40,   31,   39,   45,
       88,   45,   89,   45,   45,   89,   38,   79,   79,   79,
       30,   31,   32,   33,  106,   34,   35,   36,   37,   92,
       38,   34,   40,   31,   44,   39,   44,  172,  172,   48,
      192,  192,   38,   64,  100,  100,  369,   44,   48,   44,
      106,   48,   48,   48,  368,   44,   47,   47,   88,   47,
       47,   47,   47,   47,   47,   47,   47,   47,   47,   47,

       47,   47,   92,  108,   47,  100,  101,  101,  101,   47,
       47,   47,   47,   47,   47,   49,   49,   49,   49,   49,
      122,   49,   49,   49,  112,   49,  346,  109,  110,  108,
      100,  122,  111,   49,   55,  115,  115,  115,   47,   47,
       47,   47,   50,   50,   50,   50,   50,   55,   50,   50,
       50,  112,   50,  109,  110,  127,  134,   49,  111,  170,
       49,   55,  269,   47,   47,   47,  321,   52,  321,   53,
      119,  119,  119,   55,  128,  119,  267,   52,  129,   53,
       52,  127,   53,  134,   50,   51,   51,   51,   51,   51,
      130,   51,   51,   51,   52,   51,   53,   54,   56,   57,

      128,   51,   54,   52,  129,   53,   52,  170,   53,   54,
       54,   56,   57,   56,   51,  215,  130,   57,  121,  121,
      121,   60,  356,  121,   54,   56,   57,   51,   51,   54,
      131,  133,  213,   60,   60,   54,   54,   56,   57,   56,
       51,   58,   59,   57,  135,   58,   59,  356,   60,  136,
      137,  138,  139,  135,   58,   59,  131,  133,   58,   60,
       60,  142,  345,  142,  345,  142,  142,  208,   58,   59,
      151,  135,   58,   59,  151,  136,  137,  138,  139,  135,
       58,   59,  151,  177,   58,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,

      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  118,  118,  118,  118,  118,
      118,  118,  118,  118,  118,  140,  141,  145,  141,  145,
      188,  145,  145,  147,  176,  147,  173,  147,  147,  141,
      150,  141,  148,  148,  148,  159,  159,  141,  161,  239,
      239,  140,  149,  149,  149,  149,  149,  149,  149,  149,

      149,  149,  149,  149,  149,  149,  149,  149,  144,  152,
      149,  159,  159,  188,  161,  149,  149,  149,  149,  149,
      149,  152,  152,  126,  166,  152,  152,  152,  152,  154,
      200,  154,  158,  154,  154,  157,  160,  158,  162,  153,
      160,  162,  157,  116,  149,  149,  149,  149,  153,  153,
      166,  153,  153,  180,  180,  180,  153,  200,  158,  365,
      153,  157,  160,  158,  162,  183,  160,  162,  157,  149,
      149,  149,  155,  155,  155,  155,  155,  105,  155,  155,
      155,  104,  155,  163,  365,  156,  156,  156,  156,  156,
      153,  156,  156,  156,  164,  156,  167,  163,  165,  201,

      167,   99,  168,  164,  202,  165,   87,  164,  168,  204,
      163,  169,  169,  183,  155,  185,  185,   74,  156,  190,
      190,  164,  167,  163,  165,  201,  167,  156,  168,  164,
      202,  165,  205,  164,  168,   73,  204,  169,  169,  194,
      194,  194,  238,  220,  156,   72,  185,  206,  206,  206,
      190,  211,  211,  211,  238,   65,  211,  256,  256,  205,
      212,  212,  212,  259,  259,  212,   46,  214,  214,  214,
      220,  185,  214,  286,  286,  190,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,

      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
      210,  210,  210,  210,  210,  210,  221,  222,  223,  224,
       27,  225,  226,  227,  228,  229,   24,  231,  232,  233,
      235,  235,  235,  237,  237,  237,  248,   20,  244,   15,
      248,  251,  221,  222,  244,  223,  224,  225,  226,  227,
      228,  240,  229,  231,  232,  277,  233,  287,  287,    0,

      240,  240,  248,  240,  240,  244,  248,  251,  240,  245,
      244,  281,  240,  241,  241,  241,  241,  241,  245,  241,
      241,  241,  277,  241,  242,  242,  242,  242,  242,    0,
      242,  242,  242,  243,  242,  246,  245,  241,  281,  243,
        0,  247,  240,  246,  245,  263,    0,  249,  255,  247,
      242,  249,  250,  303,  303,  241,  252,  265,  250,  243,
      252,  246,  255,  255,  241,  243,  242,  247,  253,  246,
        0,  263,  253,  249,  254,  247,  242,  249,  266,  250,
      254,  273,  252,  265,  250,  275,  252,  278,  279,  280,
      282,  284,  285,  290,  253,  291,  255,  289,  253,  292,

      289,  254,  291,  294,  266,  295,  254,  273,  288,  288,
      294,  275,  293,  278,  279,  280,  282,  284,  285,  290,
      288,  291,  293,  289,  297,  292,  289,  296,  291,  294,
      297,  295,  296,  299,  298,  300,  294,  301,    0,  293,
      298,  305,  305,  308,  301,  307,    0,  310,  293,  311,
      302,  297,  312,  296,    0,  314,  297,  315,  296,  299,
      298,  300,  316,  301,  302,  302,  298,  317,  318,  308,
      301,    0,  307,  310,  320,  322,  311,  322,  312,  313,
      313,  313,  314,  315,  324,  333,  320,  323,  316,  313,
      325,  325,  325,  326,  317,  318,  331,  323,  302,  326,

      325,  322,  329,  322,  327,  332,  328,  327,  329,  330,
      324,  328,  333,  334,  323,  336,  335,  335,  335,  330,
      326,    0,  331,  323,    0,  326,  335,    0,  325,  329,
      327,  341,  328,  327,  329,  342,  330,  328,  343,  334,
      344,  336,  337,  337,  337,  330,  338,  338,  338,  340,
      340,  340,  337,  332,  325,  348,  338,  348,  341,  340,
      355,  342,    0,  359,  343,  351,  344,  347,  347,  347,
      349,  349,  349,  351,  350,  350,  350,  347,  352,    0,
      349,  348,  364,  348,  350,  352,  355,  353,  354,  359,
        0,  367,  351,    0,  353,  354,  357,  357,  357,  351,

      360,  360,  360,  376,  352,  347,  357,    0,  349,  364,
      360,  352,  350,  353,  354,  362,  362,  362,  367,  370,
      353,  354,  366,  366,  366,  362,  370,  372,  371,  374,
      376,  347,  366,  371,  349,  374,  375,  388,  350,  372,
      373,  373,  373,  378,    0,  370,    0,  377,  377,  377,
      373,  391,  370,  372,  396,  371,  374,  377,    0,  371,
        0,  374,  375,  388,  372,  379,  379,  379,  403,  397,
      378,  380,  380,  380,  384,  379,  384,  391,  373,    0,
      396,  380,  382,  382,  382,  383,  383,  383,  385,  385,
      385,  404,  382,  398,  403,  383,  397,  399,  385,    0,

        0,  384,  384,  405,  373,  386,  386,  386,  389,  389,
      389,  392,  392,  392,  406,  386,  409,  404,  389,  400,
      398,  392,  413,  383,  399,  400,  385,  394,  394,  394,
      405,  407,    0,  407,  410,  415,  410,  394,  411,  412,
        0,  406,  409,  386,  417,  412,  400,  419,  413,  383,
      421,  400,  385,  414,  423,  414,  416,  426,  407,  407,
      410,  415,  410,    0,  416,  411,  412,  418,  418,  386,
      417,  412,  422,    0,  419,  420,    0,  421,  422,  414,
      423,  414,  416,  424,  420,  426,    0,    0,  424,    0,
      416,    0,    0,  418,  418,    0,    0,    0,    0,  422,

        0,    0,  420,    0,  422,    0,    0,    0,    0,  424,
      420,  426,    0,    0,  424,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  429,  429,  429,  429,  429,  429,  429,  429,  429,
      429,  430,  430,  430,  430,  430,  430,  430,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  430,  430,  430,
      430,  430,  430,  430,  430,  430,  430,  431,  431,  431,
      431,  431,  431,  431,  431,  431,  431,  431,  431,  431,
      431,  431,  431,  431,  431,  431,  431,  431,  431,  431,
      431,  431,  431,  432,    0,    0,    0,  432,  432,  432,

      432,  432,  432,  432,  432,  432,  432,  432,  432,  432,
      432,  432,  432,  432,  432,  432,  432,  432,  432,  433,
      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,
      433,  433,  433,  433,  433,  433,  433,  433,  433,  433,
      433,  433,  433,  433,  433,  434,  434,  434,  434,  434,
      434,  434,  435,  435,    0,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  435,  435,
      435,  435,  435,  435,  435,  435,  435,  435,  436,  436,
      436,  436,  436,  436,  436,  436,  436,  436,  436,  436,
      436,  436,  436,  436,  436,  436,  436,  436,  436,  436,

      436,  436,  436,  436,  437,  437,  437,    0,  437,  437,
        0,  437,    0,    0,  437,  437,  437,  437,  437,  437,
      437,  437,  438,  438,    0,    0,    0,    0,  438,  438,
      438,  438,  438,  438,  438,  439,    0,  439,    0,    0,
        0,  439,  439,    0,  439,    0,    0,    0,  439,    0,
        0,    0,  439,  439,  439,  439,  439,  439,  439,  440,
        0,  440,    0,  440,  440,    0,    0,    0,    0,    0,
      440,  440,  440,  440,  440,  440,  440,  441,    0,    0,
      441,  441,  441,  441,  441,    0,    0,    0,  441,  441,
      441,  441,  441,  441,  441,  442,  442,    0,  442,  442,

      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  442,  442,  442,  442,  442,  442,  442,  442,  442,
      442,  443,    0,    0,    0,  443,    0,  443,  443,    0,
        0,    0,    0,  443,  443,  443,  443,  443,  443,  443,
      444,  444,  444,  444,  444,  444,  444,    0,  444,    0,
        0,  444,  444,  444,  444,  444,  444,  444,  444,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  445,  445,  445,  445,  445,
      445,  445,  445,  445,  445,  446,  446,  446,  446,  446,
      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,

      446,  446,  446,  446,  446,  446,  446,  446,  446,  446,
      446,  447,  447,  447,    0,    0,    0,    0,  447,  447,
      447,  447,  447,  447,  447,  447,  448,  448,  448,  448,
      448,  448,  448,    0,  448,  448,  448,  448,  448,  448,
      448,  448,  448,  448,  448,  448,  448,  448,  448,  448,
      448,  448,  449,    0,    0,    0,  449,  449,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449,  449,  449,
      449,  449,  449,  449,  449,  449,  449,  449,  450,  450,
      450,    0,    0,    0,    0,  450,  450,  450,  450,  450,
      450,  450,  450,  451,  451,  451,  451,  451,  451,    0,

      451,  451,  451,  451,  451,  451,  451,  451,  451,  451,
      451,  451,  451,  451,  451,  451,  451,  451,  451,  452,
        0,  452,    0,    0,    0,    0,    0,    0,    0,    0,
        0,    0,    0,  452,  452,  452,  452,  452,  452,  452,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  453,  453,  453,  453,
      453,  453,  453,  453,  453,  453,  454,  454,    0,    0,
        0,    0,  454,  454,  454,  454,  454,  454,  454,  454,
      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,
      455,  455,  455,  455,  455,  455,  455,  455,  455,  455,

      455,  455,  455,  455,  455,  455,  456,  456,    0,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  456,  456,  456,  456,  456,  456,  456,  456,
      456,  456,  457,  457,  457,    0,    0,    0,  457,  457,
      457,  457,  457,  457,  457,  458,    0,  458,    0,    0,
        0,  458,  458,    0,  458,    0,    0,    0,  458,    0,
        0,    0,  458,  458,  458,  458,  458,  458,  458,  459,
        0,  459,    0,  459,  459,    0,    0,    0,    0,    0,
      459,  459,  459,  459,  459,  459,  459,  460,  460,  460,
      460,  460,    0,    0,    0,  460,  460,  460,  460,  460,

      460,  460,  461,    0,    0,    0,  461,    0,    0,    0,
        0,    0,    0,    0,  461,  461,  461,  461,  461,  461,
      461,  462,    0,    0,  462,    0,  462,    0,  462,  462,
        0,    0,  462,  462,    0,  462,  462,  462,  462,  462,
      462,  462,  463,  463,  463,  463,  463,  463,  463,  463,
      463,  463,  463,  463,  463,  463,  463,  463,  463,  463,
      463,  463,  463,  463,  463,  463,  463,  463,  464,    0,
        0,    0,    0,    0,  464,  464,    0,  464,  464,  464,
        0,    0,    0,  464,  464,  464,  464,  464,  464,  464,
      465,    0,    0,  465,  465,  465,  465,  465,  465,  465,

        0,  465,  465,    0,  465,  465,  465,  465,  465,  465,
      465,  465,  466,  466,  466,  466,  466,  466,  466,    0,
      466,    0,    0,  466,  466,  466,  466,  466,  466,  466,
      466,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  467,  467,  467,
      467,  467,  467,  467,  467,  467,  467,  468,    0,    0,
        0,    0,    0,    0,  468,    0,    0,    0,    0,  468,
      468,  468,    0,    0,  468,  468,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,
      469,  469,  469,  469,  469,  469,  469,  469,  469,  469,

      469,  469,  470,  470,  470,    0,    0,    0,    0,  470,
      470,  470,  470,  470,  470,  470,  470,  471,  471,  471,
      471,  471,  471,  471,    0,  471,  471,  471,  471,  471,
      471,  471,  471,  471,  471,  471,  471,  471,  471,  471,
      471,  471,  471,  472,    0,    0,    0,  472,  472,  472,
      472,  472,  472,  472,  472,  472,  472,  472,  472,  472,
      472,  472,  472,  472,  472,  472,  472,  472,  472,  473,
      473,  473,    0,    0,    0,    0,  473,  473,  473,  473,
      473,  473,  473,  473,  474,  474,  474,  474,  474,  474,
        0,  474,  474,  474,  474,  474,  474,  474,  474,  474,

      474,  474,  474,  474,  474,  474,  474,  474,  474,  474,
      475,  475,    0,    0,    0,    0,    0,  475,    0,    0,
        0,    0,    0,    0,  475,    0,    0,  475,    0,  475,
      476,  476,  476,  476,  476,  476,  476,  477,    0,    0,
        0,    0,    0,  477,  477,  477,  477,    0,    0,    0,
        0,  477,  477,  477,  477,  477,  477,  477,  477,  478,
      478,  478,  478,  478,  478,  478,  478,  478,  478,  478,
      478,  478,  478,  478,  478,  478,  478,  478,  478,  478,
      478,  478,  478,  478,  478,  479,  479,    0,    0,    0,
        0,    0,  479,    0,    0,    0,    0,    0,    0,  479,

        0,    0,  479,    0,  479,  480,    0,    0,    0,    0,
        0,  480,  480,  480,  481,  481,    0,    0,    0,    0,
      481,  481,  481,  481,  481,  481,  481,  481,  482,  482,
      482,  482,  482,  482,  482,  482,  482,  482,  482,  482,
      482,  482,  482,  482,  482,  482,  482,  482,  482,  482,
      482,  482,  482,  482,  483,  483,  483,  483,  483,  483,
      483,  483,  483,  483,  483,  483,  483,  483,  483,  483,
      483,  483,  483,  483,  483,  483,  483,  483,  483,  483,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,
      484,  484,  484,  484,  484,  484,  484,  484,  484,  484,

      484,  484,  484,  484,  484,  484,  485,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  485,  485,  485,  485,  485,  485,  485,  485,
      485,  485,  486,  486,    0,  486,  486,  486,  486,  486,
      486,  486,  486,  486,  486,  486,  486,  486,  486,  486,
      486,  486,  486,  486,  486,  486,  486,  486,  487,  487,
        0,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  487,  487,  487,  487,  487,  487,
      487,  487,  487,  487,  488,  488,    0,  488,  488,  488,
      488,  488,  488,  488,  488,  488,  488,  488,  488,  488,

      488,  488,  488,  488,  488,  488,  488,  488,  488,  488,
      489,  489,    0,  489,  489,  489,  489,  489,  489,  489,
      489,  489,  489,  489,  489,  489,  489,  489,  489,  489,
      489,  489,  489,  489,  489,  489,  490,  490,  490,    0,
      490,  490,    0,  490,    0,    0,  490,  490,  490,  490,
      490,  490,  490,  490,  491,    0,    0,  491,    0,  491,
        0,  491,  491,    0,    0,  491,  491,    0,  491,  491,
      491,  491,  491,  491,  491,  492,  492,    0,    0,    0,
        0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
      492,  492,  492,  492,  492,  492,  492,  493,    0,    0,

      493,  493,  493,  493,  493,  493,  493,    0,  493,  493,
        0,  493,  493,  493,  493,  493,  493,  493,  493,  494,
      494,  494,  494,  494,  494,  494,    0,  494,    0,    0,
      494,  494,  494,  494,  494,  494,  494,  494,  495,  495,
      495,  495,  495,  495,  495,  495,  495,  495,  495,  495,
      495,  495,  495,  495,  495,  495,  495,  495,  495,  495,
      495,  495,  495,  495,  496,  496,    0,    0,    0,    0,
      496,  496,  496,  497,  497,    0,    0,    0,    0,  497,
      497,  497,  498,  498,    0,    0,    0,    0,  498,  498,
      498,  499,  499,    0,    0,    0,    0,  499,  499,  499,

      500,  500,    0,  500,  500,  500,  500,  500,  500,  500,
      500,  500,  500,  500,  500,  500,  500,  500,  500,  500,
      500,  500,  500,  500,  500,  500,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,
      428,  428,  428,  428,  428,  428,  428,  428,  428,  428,

      428,  428,  428,  428,  428,  428,  428
    } ;

/* Table of booleans, true if rule could match eol. */
static yyconst flex_int32_t yy_rule_can_match_eol[96] =
    {   0,
0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 1, 0, 0, 1, 
    0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 1, 1, 0, 1, 1, 1, 1, 
    1, 1, 1, 1, 0, 0, 0, 0, 1, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 1, 
    0, 0, 0, 1, 0, 1, 0, 0, 0, 1, 1, 0, 1, 1, 0, 0,     };

static yy_state_type yy_last_accepting_state;
static char *yy_last_accepting_cpos;

extern int yy_flex_debug;
int yy_flex_debug = 0;

/* The intent behind this definition is that it'll catch
 * any uses of REJECT which flex missed.
 */
#define REJECT reject_used_but_not_detected
#define yymore() yymore_used_but_not_detected
#define YY_MORE_ADJ 0
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#line 1 "lexer.l"
/* Lex file for rsyslog config format v2 (RainerScript).
* Please note: this file introduces the new config format, but maintains
* backward compatibility. In order to do so, the grammar is not 100% clean,
* but IMHO still sufficiently easy both to understand for programmers
* maitaining the code as well as users writing the config file. Users are,
* of course, encouraged to use new constructs only. But it needs to be noted
* that some of the legacy constructs (specifically the in-front-of-action
* PRI filter) are very hard to beat in ease of use, at least for simpler
* cases. So while we hope that cfsysline support can be dropped some time in
* the future, we will probably keep these useful constructs.
*
* Copyright 2011-2012 Rainer Gerhards and Adiscon GmbH.
*
* This file is part of the rsyslog runtime library.
*
* The rsyslog runtime library is free software: you can redistribute it and/or modify
* it under the terms of the GNU Lesser General Public License as published by
* the Free Software Foundation, either version 3 of the License, or
* (at your option) any later version.
*
* The rsyslog runtime library is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU Lesser General Public License for more details.
*
* You should have received a copy of the GNU Lesser General Public License
* along with the rsyslog runtime library.  If not, see <http://www.gnu.org/licenses/>.
*
* A copy of the GPL can be found in the file "COPYING" in this distribution.
* A copy of the LGPL can be found in the file "COPYING.LESSER" in this distribution.
*/
/*%option noyywrap nodefault case-insensitive */
/* avoid compiler warning: `yyunput' defined but not used */
#define YY_NO_INPUT 1

/* INOBJ is selected if we are inside an object (name/value pairs!) */

/* COMMENT is "the usual trick" to handle C-style comments */

/* INCL is in $IncludeConfig processing (skip to include file) */

/* LINENO: support for setting the linenumber */

/* INCALL: support for the call statement */

/* EXPR is a bit ugly, but we need it to support pre v6-syntax. The problem
* is that cfsysline statement start with $..., the same like variables in
* an expression. However, cfsysline statements can never appear inside an
* expression. So we create a specific expr mode, which is turned on after 
* we lexed a keyword that needs to be followed by an expression (using 
* knowledge from the upper layer...). In expr mode, we strictly do
* expression-based parsing. Expr mode is stopped when we reach a token
* that can not be part of an expression (currently only "then"). As I
* wrote this ugly, but the price needed to pay in order to remain
* compatible to the previous format.
*/
#line 63 "lexer.l"
#include <ctype.h>
#include <stdio.h>
#include <stdlib.h>
#include <strings.h>
#include <libestr.h>
#include "rainerscript.h"
#include "parserif.h"
#include "grammar.h"
static int preCommentState;	/* save for lex state before a comment */

struct bufstack {
	struct bufstack *prev;
	YY_BUFFER_STATE bs;
	int lineno;
	char *fn;
	es_str_t *estr;
} *currbs = NULL;

char *cnfcurrfn;			/* name of currently processed file */

int popfile(void);
int cnfSetLexFile(char *fname);

extern int yydebug;

/* somehow, I need these prototype even though the headers are 
 * included. I guess that's some autotools magic I don't understand...
 */
//char *strdup(char*);
int fileno(FILE *stream);

#line 1436 "lexer.c"

#define INITIAL 0
#define INOBJ 1
#define COMMENT 2
#define INCL 3
#define LINENO 4
#define INCALL 5
#define EXPR 6

#ifndef YY_NO_UNISTD_H
/* Special case for "unistd.h", since it is non-ANSI. We include it way
 * down here because we want the user's section 1 to have been scanned first.
 * The user has a chance to override it with an option.
 */
#include <unistd.h>
#endif

#ifndef YY_EXTRA_TYPE
#define YY_EXTRA_TYPE void *
#endif

static int yy_init_globals (void );

/* Accessor methods to globals.
   These are made visible to non-reentrant scanners for convenience. */

int yylex_destroy (void );

int yyget_debug (void );

void yyset_debug (int debug_flag  );

YY_EXTRA_TYPE yyget_extra (void );

void yyset_extra (YY_EXTRA_TYPE user_defined  );

FILE *yyget_in (void );

void yyset_in  (FILE * in_str  );

FILE *yyget_out (void );

void yyset_out  (FILE * out_str  );

int yyget_leng (void );

char *yyget_text (void );

int yyget_lineno (void );

void yyset_lineno (int line_number  );

/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap (void );
#else
extern int yywrap (void );
#endif
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy (char *,yyconst char *,int );
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * );
#endif

#ifndef YY_NO_INPUT

#ifdef __cplusplus
static int yyinput (void );
#else
static int input (void );
#endif

#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#ifdef __ia64__
/* On IA-64, the buffer size is 16k, not 8k */
#define YY_READ_BUF_SIZE 16384
#else
#define YY_READ_BUF_SIZE 8192
#endif /* __ia64__ */
#endif

/* Copy whatever the last rule matched to the standard output. */
#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO do { if (fwrite( yytext, yyleng, 1, yyout )) {} } while (0)
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER_LVALUE->yy_is_interactive ) \
		{ \
		int c = '*'; \
		size_t n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else \
		{ \
		errno=0; \
		while ( (result = fread(buf, 1, max_size, yyin))==0 && ferror(yyin)) \
			{ \
			if( errno != EINTR) \
				{ \
				YY_FATAL_ERROR( "input in flex scanner failed" ); \
				break; \
				} \
			errno=0; \
			clearerr(yyin); \
			} \
		}\
\

#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* end tables serialization structures and prototypes */

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL_IS_OURS 1

extern int yylex (void);

#define YY_DECL int yylex (void)
#endif /* !YY_DECL */

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		YY_CURRENT_BUFFER_LVALUE->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

/** The main scanner function which does all the work.
 */
YY_DECL
{
	register yy_state_type yy_current_state;
	register char *yy_cp, *yy_bp;
	register int yy_act;
    
#line 96 "lexer.l"


 /* keywords */
#line 1634 "lexer.c"

	if ( !(yy_init) )
		{
		(yy_init) = 1;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! (yy_start) )
			(yy_start) = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! YY_CURRENT_BUFFER ) {
			yyensure_buffer_stack ();
			YY_CURRENT_BUFFER_LVALUE =
				yy_create_buffer(yyin,YY_BUF_SIZE );
		}

		yy_load_buffer_state( );
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_cp = (yy_c_buf_p);

		/* Support of yytext. */
		*yy_cp = (yy_hold_char);

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = (yy_start);
		yy_current_state += YY_AT_BOL();
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			if ( yy_accept[yy_current_state] )
				{
				(yy_last_accepting_state) = yy_current_state;
				(yy_last_accepting_cpos) = yy_cp;
				}
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 429 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 3127 );

yy_find_action:
		yy_act = yy_accept[yy_current_state];
		if ( yy_act == 0 )
			{ /* have to back up */
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			yy_act = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;

		if ( yy_act != YY_END_OF_BUFFER && yy_rule_can_match_eol[yy_act] )
			{
			int yyl;
			for ( yyl = 0; yyl < yyleng; ++yyl )
				if ( yytext[yyl] == '\n' )
					   
    yylineno++;
;
			}

do_action:	/* This label is used only to access EOF actions. */

		switch ( yy_act )
	{ /* beginning of action switch */
			case 0: /* must back up */
			/* undo the effects of YY_DO_BEFORE_ACTION */
			*yy_cp = (yy_hold_char);
			yy_cp = (yy_last_accepting_cpos);
			yy_current_state = (yy_last_accepting_state);
			goto yy_find_action;

case 1:
YY_RULE_SETUP
#line 99 "lexer.l"
{ BEGIN EXPR; return IF; }
	YY_BREAK
case 2:
YY_RULE_SETUP
#line 100 "lexer.l"
{ BEGIN INITIAL; return THEN; }
	YY_BREAK
case 3:
YY_RULE_SETUP
#line 101 "lexer.l"
{ BEGIN INITIAL; return ';'; }
	YY_BREAK
case 4:
YY_RULE_SETUP
#line 102 "lexer.l"
{ return OR; }
	YY_BREAK
case 5:
YY_RULE_SETUP
#line 103 "lexer.l"
{ return AND; }
	YY_BREAK
case 6:
YY_RULE_SETUP
#line 104 "lexer.l"
{ return NOT; }
	YY_BREAK
case 7:
#line 106 "lexer.l"
case 8:
#line 107 "lexer.l"
case 9:
#line 108 "lexer.l"
case 10:
#line 109 "lexer.l"
case 11:
#line 110 "lexer.l"
case 12:
#line 111 "lexer.l"
case 13:
#line 112 "lexer.l"
case 14:
#line 113 "lexer.l"
case 15:
#line 114 "lexer.l"
case 16:
#line 115 "lexer.l"
case 17:
#line 116 "lexer.l"
case 18:
YY_RULE_SETUP
#line 116 "lexer.l"
{ return yytext[0]; }
	YY_BREAK
case 19:
YY_RULE_SETUP
#line 117 "lexer.l"
{ return CMP_EQ; }
	YY_BREAK
case 20:
YY_RULE_SETUP
#line 118 "lexer.l"
{ return CMP_LE; }
	YY_BREAK
case 21:
YY_RULE_SETUP
#line 119 "lexer.l"
{ return CMP_GE; }
	YY_BREAK
case 22:
#line 121 "lexer.l"
case 23:
YY_RULE_SETUP
#line 121 "lexer.l"
{ return CMP_NE; }
	YY_BREAK
case 24:
YY_RULE_SETUP
#line 122 "lexer.l"
{ return CMP_LT; }
	YY_BREAK
case 25:
YY_RULE_SETUP
#line 123 "lexer.l"
{ return CMP_GT; }
	YY_BREAK
case 26:
YY_RULE_SETUP
#line 124 "lexer.l"
{ return CMP_CONTAINS; }
	YY_BREAK
case 27:
YY_RULE_SETUP
#line 125 "lexer.l"
{ return CMP_CONTAINSI; }
	YY_BREAK
case 28:
YY_RULE_SETUP
#line 126 "lexer.l"
{ return CMP_STARTSWITH; }
	YY_BREAK
case 29:
YY_RULE_SETUP
#line 127 "lexer.l"
{ return CMP_STARTSWITHI; }
	YY_BREAK
case 30:
#line 129 "lexer.l"
case 31:
#line 130 "lexer.l"
case 32:
YY_RULE_SETUP
#line 130 "lexer.l"
{ yylval.n = strtoll(yytext, NULL, 0); return NUMBER; }
	YY_BREAK
case 33:
YY_RULE_SETUP
#line 131 "lexer.l"
{ yylval.s = strdup(yytext); return VAR; }
	YY_BREAK
case 34:
/* rule 34 can match eol */
YY_RULE_SETUP
#line 132 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 35:
/* rule 35 can match eol */
YY_RULE_SETUP
#line 137 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
case 36:
/* rule 36 can match eol */
YY_RULE_SETUP
#line 142 "lexer.l"

	YY_BREAK
case 37:
YY_RULE_SETUP
#line 143 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return FUNC; }
	YY_BREAK
case 38:
YY_RULE_SETUP
#line 145 "lexer.l"
{ dbgprintf("invalid char in expr: %s\n", yytext); }
	YY_BREAK
case 39:
/* rule 39 can match eol */
YY_RULE_SETUP
#line 146 "lexer.l"

	YY_BREAK
case 40:
YY_RULE_SETUP
#line 147 "lexer.l"
{ dbgprintf("invalid char in CALL stmt: %s\n", yytext); }
	YY_BREAK
case 41:
YY_RULE_SETUP
#line 148 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  BEGIN INITIAL;
				  return NAME; }
	YY_BREAK
case 42:
YY_RULE_SETUP
#line 151 "lexer.l"
{ return '&'; }
	YY_BREAK
case 43:
YY_RULE_SETUP
#line 152 "lexer.l"
{ return '{'; }
	YY_BREAK
case 44:
YY_RULE_SETUP
#line 153 "lexer.l"
{ return '}'; }
	YY_BREAK
case 45:
YY_RULE_SETUP
#line 154 "lexer.l"
{ return STOP; }
	YY_BREAK
case 46:
YY_RULE_SETUP
#line 155 "lexer.l"
{ return ELSE; }
	YY_BREAK
case 47:
YY_RULE_SETUP
#line 156 "lexer.l"
{ BEGIN INCALL; return CALL; }
	YY_BREAK
case 48:
YY_RULE_SETUP
#line 157 "lexer.l"
{ BEGIN EXPR; return SET; }
	YY_BREAK
case 49:
YY_RULE_SETUP
#line 158 "lexer.l"
{ BEGIN EXPR; return UNSET; }
	YY_BREAK
/* line number support because the "preprocessor" combines lines and so needs
  * to tell us the real source line.
  */
case 50:
YY_RULE_SETUP
#line 162 "lexer.l"
{ BEGIN LINENO; }
	YY_BREAK
case 51:
YY_RULE_SETUP
#line 163 "lexer.l"
{ yylineno = atoi(yytext) - 1; }
	YY_BREAK
case 52:
YY_RULE_SETUP
#line 164 "lexer.l"
{ BEGIN INITIAL; }
	YY_BREAK
case 53:
/* rule 53 can match eol */
YY_RULE_SETUP
#line 165 "lexer.l"

	YY_BREAK
/* $IncludeConfig must be detected as part of CFSYSLINE, because this is
  * always the longest match :-(
  */
case 54:
/* rule 54 can match eol */
YY_RULE_SETUP
#line 169 "lexer.l"

	YY_BREAK
case 55:
YY_RULE_SETUP
#line 170 "lexer.l"
{ if(cnfDoInclude(yytext) != 0)
					yyterminate();
				  BEGIN INITIAL; }
	YY_BREAK
case 56:
/* rule 56 can match eol */
YY_RULE_SETUP
#line 173 "lexer.l"
{ yylval.objType = CNFOBJ_GLOBAL;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 57:
/* rule 57 can match eol */
YY_RULE_SETUP
#line 175 "lexer.l"
{ yylval.objType = CNFOBJ_TPL;
				  BEGIN INOBJ; return BEGIN_TPL; }
	YY_BREAK
case 58:
/* rule 58 can match eol */
YY_RULE_SETUP
#line 177 "lexer.l"
{ yylval.objType = CNFOBJ_RULESET;
				  BEGIN INOBJ; return BEGIN_RULESET; }
	YY_BREAK
case 59:
/* rule 59 can match eol */
YY_RULE_SETUP
#line 179 "lexer.l"
{ yylval.objType = CNFOBJ_PROPERTY;
				  BEGIN INOBJ; return BEGIN_PROPERTY; }
	YY_BREAK
case 60:
/* rule 60 can match eol */
YY_RULE_SETUP
#line 181 "lexer.l"
{ yylval.objType = CNFOBJ_CONSTANT;
				  BEGIN INOBJ; return BEGIN_CONSTANT; }
	YY_BREAK
case 61:
/* rule 61 can match eol */
YY_RULE_SETUP
#line 183 "lexer.l"
{ yylval.objType = CNFOBJ_INPUT;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 62:
/* rule 62 can match eol */
YY_RULE_SETUP
#line 185 "lexer.l"
{ yylval.objType = CNFOBJ_MODULE;
				  BEGIN INOBJ; return BEGINOBJ; }
	YY_BREAK
case 63:
/* rule 63 can match eol */
YY_RULE_SETUP
#line 187 "lexer.l"
{ BEGIN INOBJ; return BEGIN_ACTION; }
	YY_BREAK
case 64:
YY_RULE_SETUP
#line 188 "lexer.l"
{
				  yylval.s = strdup(rmLeadingSpace(yytext)); return PROPFILT; }
	YY_BREAK
case 65:
YY_RULE_SETUP
#line 190 "lexer.l"
{ yylval.s = strdup(rmLeadingSpace(yytext)); return PRIFILT; }
	YY_BREAK
case 66:
#line 192 "lexer.l"
case 67:
#line 193 "lexer.l"
case 68:
/* rule 68 can match eol */
#line 194 "lexer.l"
case 69:
/* rule 69 can match eol */
#line 195 "lexer.l"
case 70:
/* rule 70 can match eol */
#line 196 "lexer.l"
case 71:
/* rule 71 can match eol */
#line 197 "lexer.l"
case 72:
/* rule 72 can match eol */
YY_RULE_SETUP
#line 197 "lexer.l"
{ yylval.s = yytext; return LEGACY_ACTION; }
	YY_BREAK
case 73:
YY_RULE_SETUP
#line 198 "lexer.l"
{ BEGIN INITIAL; return ENDOBJ; }
	YY_BREAK
case 74:
YY_RULE_SETUP
#line 199 "lexer.l"
{ yylval.estr = es_newStrFromCStr(yytext, yyleng);
				  return NAME; }
	YY_BREAK
case 75:
#line 202 "lexer.l"
case 76:
#line 203 "lexer.l"
case 77:
#line 204 "lexer.l"
case 78:
YY_RULE_SETUP
#line 204 "lexer.l"
{ return(yytext[0]); }
	YY_BREAK
case 79:
/* rule 79 can match eol */
YY_RULE_SETUP
#line 205 "lexer.l"
{
				   yytext[yyleng-1] = '\0';
				   unescapeStr((uchar*)yytext+1, yyleng-2);
				   yylval.estr = es_newStrFromBuf(yytext+1, strlen(yytext)-1);
				   return STRING; }
	YY_BREAK
/*yylval.estr = es_newStrFromBuf(yytext+1, yyleng-2);
				  return VALUE; }*/
case 80:
YY_RULE_SETUP
#line 212 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 81:
YY_RULE_SETUP
#line 213 "lexer.l"
{ preCommentState = YY_START; BEGIN COMMENT; }
	YY_BREAK
case 82:
YY_RULE_SETUP
#line 214 "lexer.l"
{ BEGIN preCommentState; }
	YY_BREAK
case 83:
/* rule 83 can match eol */
YY_RULE_SETUP
#line 215 "lexer.l"

	YY_BREAK
case 84:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 216 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 85:
/* rule 85 can match eol */
YY_RULE_SETUP
#line 217 "lexer.l"

	YY_BREAK
case 86:
YY_RULE_SETUP
#line 218 "lexer.l"
{ dbgprintf("INOBJ: invalid char '%s'\n", yytext); }
	YY_BREAK
case 87:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 219 "lexer.l"
{ /* see comment on $IncludeConfig above */
				  if(!strncasecmp(yytext, "$includeconfig ", 14)) {
					yyless(14);
				  	BEGIN INCL;
				  } else if(!strncasecmp(yytext, "$ruleset ", 9)) {
					yylval.s = strdup(yytext);
					return LEGACY_RULESET;
				  } else {
					  cnfDoCfsysline(strdup(yytext)); 
				  }
				}
	YY_BREAK
case 88:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 230 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_TAG_SELECTOR; }
	YY_BREAK
case 89:
/* rule 89 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 231 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 90:
/* rule 90 can match eol */
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 232 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 91:
*yy_cp = (yy_hold_char); /* undo effects of setting up yytext */
(yy_c_buf_p) = yy_cp -= 1;
YY_DO_BEFORE_ACTION; /* set up yytext again */
YY_RULE_SETUP
#line 233 "lexer.l"
{ yylval.s = strdup(yytext); return BSD_HOST_SELECTOR; }
	YY_BREAK
case 92:
/* rule 92 can match eol */
YY_RULE_SETUP
#line 234 "lexer.l"
/* skip comments in input */
	YY_BREAK
case 93:
/* rule 93 can match eol */
YY_RULE_SETUP
#line 235 "lexer.l"
/* drop whitespace */
	YY_BREAK
case 94:
YY_RULE_SETUP
#line 236 "lexer.l"
{ dbgprintf("invalid char: %s\n", yytext);
				}
	YY_BREAK
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(INOBJ):
case YY_STATE_EOF(COMMENT):
case YY_STATE_EOF(INCL):
case YY_STATE_EOF(LINENO):
case YY_STATE_EOF(INCALL):
case YY_STATE_EOF(EXPR):
#line 238 "lexer.l"
{ if(popfile() != 0) yyterminate(); }
	YY_BREAK
case 95:
YY_RULE_SETUP
#line 240 "lexer.l"
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK
#line 2233 "lexer.c"

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - (yytext_ptr)) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = (yy_hold_char);
		YY_RESTORE_YY_MORE_OFFSET

		if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between YY_CURRENT_BUFFER and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
			YY_CURRENT_BUFFER_LVALUE->yy_input_file = yyin;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( (yy_c_buf_p) <= &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			(yy_c_buf_p) = (yytext_ptr) + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state(  );

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = (yytext_ptr) + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++(yy_c_buf_p);
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = (yy_c_buf_p);
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer(  ) )
			{
			case EOB_ACT_END_OF_FILE:
				{
				(yy_did_buffer_switch_on_eof) = 0;

				if ( yywrap( ) )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					(yy_c_buf_p) = (yytext_ptr) + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				(yy_c_buf_p) =
					(yytext_ptr) + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				(yy_c_buf_p) =
				&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)];

				yy_current_state = yy_get_previous_state(  );

				yy_cp = (yy_c_buf_p);
				yy_bp = (yytext_ptr) + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
} /* end of yylex */

/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */
static int yy_get_next_buffer (void)
{
    	register char *dest = YY_CURRENT_BUFFER_LVALUE->yy_ch_buf;
	register char *source = (yytext_ptr);
	register int number_to_move, i;
	int ret_val;

	if ( (yy_c_buf_p) > &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( YY_CURRENT_BUFFER_LVALUE->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( (yy_c_buf_p) - (yytext_ptr) - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) ((yy_c_buf_p) - (yytext_ptr)) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( YY_CURRENT_BUFFER_LVALUE->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars) = 0;

	else
		{
			int num_to_read =
			YY_CURRENT_BUFFER_LVALUE->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = YY_CURRENT_BUFFER;

			int yy_c_buf_p_offset =
				(int) ((yy_c_buf_p) - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yyrealloc((void *) b->yy_ch_buf,b->yy_buf_size + 2  );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			(yy_c_buf_p) = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = YY_CURRENT_BUFFER_LVALUE->yy_buf_size -
						number_to_move - 1;

			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[number_to_move]),
			(yy_n_chars), (size_t) num_to_read );

		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	if ( (yy_n_chars) == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart(yyin  );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			YY_CURRENT_BUFFER_LVALUE->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	if ((yy_size_t) ((yy_n_chars) + number_to_move) > YY_CURRENT_BUFFER_LVALUE->yy_buf_size) {
		/* Extend the array by 50%, plus the number we really need. */
		yy_size_t new_size = (yy_n_chars) + number_to_move + ((yy_n_chars) >> 1);
		YY_CURRENT_BUFFER_LVALUE->yy_ch_buf = (char *) yyrealloc((void *) YY_CURRENT_BUFFER_LVALUE->yy_ch_buf,new_size  );
		if ( ! YY_CURRENT_BUFFER_LVALUE->yy_ch_buf )
			YY_FATAL_ERROR( "out of dynamic memory in yy_get_next_buffer()" );
	}

	(yy_n_chars) += number_to_move;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] = YY_END_OF_BUFFER_CHAR;
	YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars) + 1] = YY_END_OF_BUFFER_CHAR;

	(yytext_ptr) = &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[0];

	return ret_val;
}

/* yy_get_previous_state - get the state just before the EOB char was reached */

    static yy_state_type yy_get_previous_state (void)
{
	register yy_state_type yy_current_state;
	register char *yy_cp;
    
	yy_current_state = (yy_start);
	yy_current_state += YY_AT_BOL();

	for ( yy_cp = (yytext_ptr) + YY_MORE_ADJ; yy_cp < (yy_c_buf_p); ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		if ( yy_accept[yy_current_state] )
			{
			(yy_last_accepting_state) = yy_current_state;
			(yy_last_accepting_cpos) = yy_cp;
			}
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 429 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		}

	return yy_current_state;
}

/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */
    static yy_state_type yy_try_NUL_trans  (yy_state_type yy_current_state )
{
	register int yy_is_jam;
    	register char *yy_cp = (yy_c_buf_p);

	register YY_CHAR yy_c = 1;
	if ( yy_accept[yy_current_state] )
		{
		(yy_last_accepting_state) = yy_current_state;
		(yy_last_accepting_cpos) = yy_cp;
		}
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 429 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 428);

	return yy_is_jam ? 0 : yy_current_state;
}

#ifndef YY_NO_INPUT
#ifdef __cplusplus
    static int yyinput (void)
#else
    static int input  (void)
#endif

{
	int c;
    
	*(yy_c_buf_p) = (yy_hold_char);

	if ( *(yy_c_buf_p) == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( (yy_c_buf_p) < &YY_CURRENT_BUFFER_LVALUE->yy_ch_buf[(yy_n_chars)] )
			/* This was really a NUL. */
			*(yy_c_buf_p) = '\0';

		else
			{ /* need more input */
			int offset = (yy_c_buf_p) - (yytext_ptr);
			++(yy_c_buf_p);

			switch ( yy_get_next_buffer(  ) )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart(yyin );

					/*FALLTHROUGH*/

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap( ) )
						return EOF;

					if ( ! (yy_did_buffer_switch_on_eof) )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					(yy_c_buf_p) = (yytext_ptr) + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) (yy_c_buf_p);	/* cast for 8-bit char's */
	*(yy_c_buf_p) = '\0';	/* preserve yytext */
	(yy_hold_char) = *++(yy_c_buf_p);

	YY_CURRENT_BUFFER_LVALUE->yy_at_bol = (c == '\n');
	if ( YY_CURRENT_BUFFER_LVALUE->yy_at_bol )
		   
    yylineno++;
;

	return c;
}
#endif	/* ifndef YY_NO_INPUT */

/** Immediately switch to a different input stream.
 * @param input_file A readable stream.
 * 
 * @note This function does not reset the start condition to @c INITIAL .
 */
    void yyrestart  (FILE * input_file )
{
    
	if ( ! YY_CURRENT_BUFFER ){
        yyensure_buffer_stack ();
		YY_CURRENT_BUFFER_LVALUE =
            yy_create_buffer(yyin,YY_BUF_SIZE );
	}

	yy_init_buffer(YY_CURRENT_BUFFER,input_file );
	yy_load_buffer_state( );
}

/** Switch to a different input buffer.
 * @param new_buffer The new input buffer.
 * 
 */
    void yy_switch_to_buffer  (YY_BUFFER_STATE  new_buffer )
{
    
	/* TODO. We should be able to replace this entire function body
	 * with
	 *		yypop_buffer_state();
	 *		yypush_buffer_state(new_buffer);
     */
	yyensure_buffer_stack ();
	if ( YY_CURRENT_BUFFER == new_buffer )
		return;

	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	YY_CURRENT_BUFFER_LVALUE = new_buffer;
	yy_load_buffer_state( );

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	(yy_did_buffer_switch_on_eof) = 1;
}

static void yy_load_buffer_state  (void)
{
    	(yy_n_chars) = YY_CURRENT_BUFFER_LVALUE->yy_n_chars;
	(yytext_ptr) = (yy_c_buf_p) = YY_CURRENT_BUFFER_LVALUE->yy_buf_pos;
	yyin = YY_CURRENT_BUFFER_LVALUE->yy_input_file;
	(yy_hold_char) = *(yy_c_buf_p);
}

/** Allocate and initialize an input buffer state.
 * @param file A readable stream.
 * @param size The character buffer size in bytes. When in doubt, use @c YY_BUF_SIZE.
 * 
 * @return the allocated buffer state.
 */
    YY_BUFFER_STATE yy_create_buffer  (FILE * file, int  size )
{
	YY_BUFFER_STATE b;
    
	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yyalloc(b->yy_buf_size + 2  );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer(b,file );

	return b;
}

/** Destroy the buffer.
 * @param b a buffer created with yy_create_buffer()
 * 
 */
    void yy_delete_buffer (YY_BUFFER_STATE  b )
{
    
	if ( ! b )
		return;

	if ( b == YY_CURRENT_BUFFER ) /* Not sure if we should pop here. */
		YY_CURRENT_BUFFER_LVALUE = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yyfree((void *) b->yy_ch_buf  );

	yyfree((void *) b  );
}

#ifndef __cplusplus
extern int isatty (int );
#endif /* __cplusplus */
    
/* Initializes or reinitializes a buffer.
 * This function is sometimes called more than once on the same buffer,
 * such as during a yyrestart() or at EOF.
 */
    static void yy_init_buffer  (YY_BUFFER_STATE  b, FILE * file )

{
	int oerrno = errno;
    
	yy_flush_buffer(b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

    /* If b is the current buffer, then yy_init_buffer was _probably_
     * called from yyrestart() or through yy_get_next_buffer.
     * In that case, we don't want to reset the lineno or column.
     */
    if (b != YY_CURRENT_BUFFER){
        b->yy_bs_lineno = 1;
        b->yy_bs_column = 0;
    }

        b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
    
	errno = oerrno;
}

/** Discard all buffered characters. On the next scan, YY_INPUT will be called.
 * @param b the buffer state to be flushed, usually @c YY_CURRENT_BUFFER.
 * 
 */
    void yy_flush_buffer (YY_BUFFER_STATE  b )
{
    	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == YY_CURRENT_BUFFER )
		yy_load_buffer_state( );
}

/** Pushes the new state onto the stack. The new state becomes
 *  the current state. This function will allocate the stack
 *  if necessary.
 *  @param new_buffer The new state.
 *  
 */
void yypush_buffer_state (YY_BUFFER_STATE new_buffer )
{
    	if (new_buffer == NULL)
		return;

	yyensure_buffer_stack();

	/* This block is copied from yy_switch_to_buffer. */
	if ( YY_CURRENT_BUFFER )
		{
		/* Flush out information for old buffer. */
		*(yy_c_buf_p) = (yy_hold_char);
		YY_CURRENT_BUFFER_LVALUE->yy_buf_pos = (yy_c_buf_p);
		YY_CURRENT_BUFFER_LVALUE->yy_n_chars = (yy_n_chars);
		}

	/* Only push if top exists. Otherwise, replace top. */
	if (YY_CURRENT_BUFFER)
		(yy_buffer_stack_top)++;
	YY_CURRENT_BUFFER_LVALUE = new_buffer;

	/* copied from yy_switch_to_buffer. */
	yy_load_buffer_state( );
	(yy_did_buffer_switch_on_eof) = 1;
}

/** Removes and deletes the top of the stack, if present.
 *  The next element becomes the new top.
 *  
 */
void yypop_buffer_state (void)
{
    	if (!YY_CURRENT_BUFFER)
		return;

	yy_delete_buffer(YY_CURRENT_BUFFER );
	YY_CURRENT_BUFFER_LVALUE = NULL;
	if ((yy_buffer_stack_top) > 0)
		--(yy_buffer_stack_top);

	if (YY_CURRENT_BUFFER) {
		yy_load_buffer_state( );
		(yy_did_buffer_switch_on_eof) = 1;
	}
}

/* Allocates the stack if it does not exist.
 *  Guarantees space for at least one push.
 */
static void yyensure_buffer_stack (void)
{
	int num_to_alloc;
    
	if (!(yy_buffer_stack)) {

		/* First allocation is just for 2 elements, since we don't know if this
		 * scanner will even need a stack. We use 2 instead of 1 to avoid an
		 * immediate realloc on the next call.
         */
		num_to_alloc = 1;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyalloc
								(num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );
								  
		memset((yy_buffer_stack), 0, num_to_alloc * sizeof(struct yy_buffer_state*));
				
		(yy_buffer_stack_max) = num_to_alloc;
		(yy_buffer_stack_top) = 0;
		return;
	}

	if ((yy_buffer_stack_top) >= ((yy_buffer_stack_max)) - 1){

		/* Increase the buffer to prepare for a possible push. */
		int grow_size = 8 /* arbitrary grow size */;

		num_to_alloc = (yy_buffer_stack_max) + grow_size;
		(yy_buffer_stack) = (struct yy_buffer_state**)yyrealloc
								((yy_buffer_stack),
								num_to_alloc * sizeof(struct yy_buffer_state*)
								);
		if ( ! (yy_buffer_stack) )
			YY_FATAL_ERROR( "out of dynamic memory in yyensure_buffer_stack()" );

		/* zero only the new slots.*/
		memset((yy_buffer_stack) + (yy_buffer_stack_max), 0, grow_size * sizeof(struct yy_buffer_state*));
		(yy_buffer_stack_max) = num_to_alloc;
	}
}

/** Setup the input buffer state to scan directly from a user-specified character buffer.
 * @param base the character buffer
 * @param size the size in bytes of the character buffer
 * 
 * @return the newly allocated buffer state object. 
 */
YY_BUFFER_STATE yy_scan_buffer  (char * base, yy_size_t  size )
{
	YY_BUFFER_STATE b;
    
	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yyalloc(sizeof( struct yy_buffer_state )  );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer(b  );

	return b;
}

/** Setup the input buffer state to scan a string. The next call to yylex() will
 * scan from a @e copy of @a str.
 * @param yystr a NUL-terminated string to scan
 * 
 * @return the newly allocated buffer state object.
 * @note If you want to scan bytes that may contain NUL values, then use
 *       yy_scan_bytes() instead.
 */
YY_BUFFER_STATE yy_scan_string (yyconst char * yystr )
{
    
	return yy_scan_bytes(yystr,strlen(yystr) );
}

/** Setup the input buffer state to scan the given bytes. The next call to yylex() will
 * scan from a @e copy of @a bytes.
 * @param yybytes the byte buffer to scan
 * @param _yybytes_len the number of bytes in the buffer pointed to by @a bytes.
 * 
 * @return the newly allocated buffer state object.
 */
YY_BUFFER_STATE yy_scan_bytes  (yyconst char * yybytes, int  _yybytes_len )
{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;
    
	/* Get memory for full buffer, including space for trailing EOB's. */
	n = _yybytes_len + 2;
	buf = (char *) yyalloc(n  );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < _yybytes_len; ++i )
		buf[i] = yybytes[i];

	buf[_yybytes_len] = buf[_yybytes_len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer(buf,n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
}

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

static void yy_fatal_error (yyconst char* msg )
{
    	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
}

/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
        int yyless_macro_arg = (n); \
        YY_LESS_LINENO(yyless_macro_arg);\
		yytext[yyleng] = (yy_hold_char); \
		(yy_c_buf_p) = yytext + yyless_macro_arg; \
		(yy_hold_char) = *(yy_c_buf_p); \
		*(yy_c_buf_p) = '\0'; \
		yyleng = yyless_macro_arg; \
		} \
	while ( 0 )

/* Accessor  methods (get/set functions) to struct members. */

/** Get the current line number.
 * 
 */
int yyget_lineno  (void)
{
        
    return yylineno;
}

/** Get the input stream.
 * 
 */
FILE *yyget_in  (void)
{
        return yyin;
}

/** Get the output stream.
 * 
 */
FILE *yyget_out  (void)
{
        return yyout;
}

/** Get the length of the current token.
 * 
 */
int yyget_leng  (void)
{
        return yyleng;
}

/** Get the current token.
 * 
 */

char *yyget_text  (void)
{
        return yytext;
}

/** Set the current line number.
 * @param line_number
 * 
 */
void yyset_lineno (int  line_number )
{
    
    yylineno = line_number;
}

/** Set the input stream. This does not discard the current
 * input buffer.
 * @param in_str A readable stream.
 * 
 * @see yy_switch_to_buffer
 */
void yyset_in (FILE *  in_str )
{
        yyin = in_str ;
}

void yyset_out (FILE *  out_str )
{
        yyout = out_str ;
}

int yyget_debug  (void)
{
        return yy_flex_debug;
}

void yyset_debug (int  bdebug )
{
        yy_flex_debug = bdebug ;
}

static int yy_init_globals (void)
{
        /* Initialization is the same as for the non-reentrant scanner.
     * This function is called from yylex_destroy(), so don't allocate here.
     */

    /* We do not touch yylineno unless the option is enabled. */
    yylineno =  1;
    
    (yy_buffer_stack) = 0;
    (yy_buffer_stack_top) = 0;
    (yy_buffer_stack_max) = 0;
    (yy_c_buf_p) = (char *) 0;
    (yy_init) = 0;
    (yy_start) = 0;

/* Defined in main.c */
#ifdef YY_STDINIT
    yyin = stdin;
    yyout = stdout;
#else
    yyin = (FILE *) 0;
    yyout = (FILE *) 0;
#endif

    /* For future reference: Set errno on error, since we are called by
     * yylex_init()
     */
    return 0;
}

/* yylex_destroy is for both reentrant and non-reentrant scanners. */
int yylex_destroy  (void)
{
    
    /* Pop the buffer stack, destroying each element. */
	while(YY_CURRENT_BUFFER){
		yy_delete_buffer(YY_CURRENT_BUFFER  );
		YY_CURRENT_BUFFER_LVALUE = NULL;
		yypop_buffer_state();
	}

	/* Destroy the stack itself. */
	yyfree((yy_buffer_stack) );
	(yy_buffer_stack) = NULL;

    /* Reset the globals. This is important in a non-reentrant scanner so the next time
     * yylex() is called, initialization will occur. */
    yy_init_globals( );

    return 0;
}

/*
 * Internal utility routines.
 */

#ifndef yytext_ptr
static void yy_flex_strncpy (char* s1, yyconst char * s2, int n )
{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
}
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen (yyconst char * s )
{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
}
#endif

void *yyalloc (yy_size_t  size )
{
	return (void *) malloc( size );
}

void *yyrealloc  (void * ptr, yy_size_t  size )
{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
}

void yyfree (void * ptr )
{
	free( (char *) ptr );	/* see yyrealloc() for (char *) cast */
}

#define YYTABLES_NAME "yytables"

#line 240 "lexer.l"


int
cnfParseBuffer(char *buf, unsigned lenBuf)
{
	struct bufstack *bs;
	int r = 0;
	yydebug = 1;
	BEGIN INITIAL;
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup("*buffer*");
	bs->bs = yy_scan_buffer(buf,lenBuf);
	bs->estr = NULL;
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;
done:	return r;
}

/* set a new buffers. Returns 0 on success, something else otherwise. */
int
cnfSetLexFile(char *fname)
{
	es_str_t *str = NULL;
	FILE *fp;
	int r = 0;
	struct bufstack *bs;

	if(fname == NULL) {
		fp = stdin;
	} else {
		if((fp = fopen(fname, "r")) == NULL) {
			r = 1;
			goto done;
		}
	}
	readConfFile(fp, &str);
	if(fp != stdin)
		fclose(fp);
	
	/* maintain stack */
	if((bs = malloc(sizeof(struct bufstack))) == NULL) {
		r = 1;
		goto done;
	}

	if(currbs != NULL)
		currbs->lineno = yylineno;
	bs->prev = currbs;
	bs->fn = strdup(fname == NULL ? "stdin" : fname);
	bs->bs = yy_scan_buffer((char*)es_getBufAddr(str),es_strlen(str));
	bs->estr = str; /* needed so we can free it later */
	currbs = bs;
	cnfcurrfn = bs->fn;
	yylineno = 1;

done:
	if(r != 0) {
		if(str != NULL)
			es_deleteStr(str);
	}
	return r;
}


/* returns 0 on success, something else otherwise */
int
popfile(void)
{
	struct bufstack *bs = currbs;

	if(bs == NULL)
		return 1;
	
	/* delete current entry. But we must not free the file name if
	 * this is the top-level file, because then it may still be used
	 * in error messages for other processing steps.
	 * TODO: change this to another method which stores the file
	 * name inside the config objects. In the longer term, this is
	 * necessary, as otherwise we may provide wrong file name information
	 * at the end of include files as well. -- rgerhards, 2011-07-22
	 */
	yy_delete_buffer(bs->bs);
	if(bs->prev != NULL)
		free(bs->fn);
	free(bs->estr);

	/* switch back to previous */
	currbs = bs->prev;
	free(bs);

	if(currbs == NULL)
		return 1; /* all processed */
	
	yy_switch_to_buffer(currbs->bs);
	yylineno = currbs->lineno;
	cnfcurrfn = currbs->fn;
	return 0;
}

void
tellLexEndParsing(void)
{
	free(cnfcurrfn);
	cnfcurrfn= NULL;
}

